function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var karma = require('karma');
var configure = _interopDefault(require('./configure.js'));

function karmatic(options) {
    return new Promise(function ($return, $error) {
        var config, server;
        config = configure(options);
        if (!options.watch) 
            { config.singleRun = true; }
        server = createServer(config);
        server.start();
        return server.completion.then($return, $error);
    });
}

function createServer(config) {
    var resolve, reject;
    var promise = new Promise(function (res, rej) {
        resolve = res;
        reject = rej;
    });
    var callback = function (code) {
        if (code === 0) 
            { return resolve(); }
        var err = Error(("Exit " + code));
        err.code = code;
        reject(err);
    };
    var server = new karma.Server(config, callback);
    server.completion = promise;
    return server;
}

module.exports = karmatic;
//# sourceMappingURL=index.js.map
